<?php

include("alerts_config.inc.php");

include("iutils.inc.php");

function getValue($value, $alert) {
    preg_match("/$value=([^\,\}]*)[\,\}]/", $alert, $matches);
    return $matches[1];
}

function printAlert($machine, $alert, $small="") {
    include("alerts_config.inc.php");

    $alertLevelNum = getValue("alertLevel", $alert);
    $lastAlert = getValue("lastAlert", $alert);
    $thresholdLevel = getValue("thresholdLevel", $alert);
    $source = getValue("source", $alert);
    $thresholdValue = getValue("thresholdValue", $alert);
    $value = getValue("value", $alert);
    $attributeName = getValue("attributeName", $alert);
    $timeTillNextAlert = getValue("timeTillNextAlert", $alert);
    $initialAlertTime = getValue("initialAlertTime", $alert);

    if ($thresholdLevel == "1") {
        $thresholdLevel = "Lower";
    }
    else if ($thresholdLevel == "2") {
        $thresholdLevel = "Upper";
    }
    else {
        $thresholdLevel = "Normal";
    }

    $alertLevel = $alertLevelNames[$alertLevelNum];
    setlocale(LC_TIME, "en_GB");
    $initialAlertTime = strftime("%x %X", intval($initialAlertTime / 1000));

    $alertLevel = strtoupper($alertLevel);

    echo <<<EOT
<item>
<title>
$alertLevel: $machine: $attributeName
</title>
<link>
http://i-scream.cs.kent.ac.uk/alerts.php?machine=$machine
</link>
<description>
&lt;pre&gt;
 Host: $source
Level: $alertLevel
 What: $attributeName
  Why: $value passed threshold $thresholdLevel:$thresholdValue
 When: $initialAlertTime
&lt;/pre&gt;
</description>
</item>
EOT;
}

function printReports($machine, $small="") {
    # Get a list of all files in the machine's directory.
    include("alerts_config.inc.php");
    $alertArray = getdirArray("$alertDirectory/$machine", 'rsort');
   
    if ($alertArray != FALSE) {
        foreach($alertArray as $file_name) {
            $input = file("$alertDirectory/$machine/$file_name");
            $input = $input[0];
            $alerts[] = $input;
        }
       
        foreach ($alerts as $alert) {
            printAlert($machine, $alert, $small);
        }
    }
}
?>

<?
echo <<<EOT
<?xml version="1.0" encoding="iso-8859-1"?>
<rss version="0.91">
<channel>
<title>i-scream alerts</title>
<link>http://i-scream.cs.kent.ac.uk/</link>
<description>Alerts being generated by the i-scream system</description>
EOT;
       if (!$machine || $machine == "ALL") {
           $machine_array = getdirArray($alertDirectory, 'asort');
           if ($machine_array != FALSE) {
               foreach ($machine_array as $machine) {
                   printReports($machine, $small);
               }
           }
       }
       else {
           printReports($machine, $small);
       }
echo <<<EOT
</channel>
</rss>
EOT;
?>
